# SPDX-FileCopyrightText: Copyright (c) 2024, Linaro Limited.
#
# SPDX-License-Identifier: MIT
---

device_type: mps3
job_name: {{ CI_JOB_NAME }}
timeouts:
  job:
    minutes: 1020
  actions:
    auto-login-action:
      minutes: 30
  connections:
    auto-login-action:
      minutes: 30
    login-action:
      minutes: 30

metadata:
  source: {{ CI_PROJECT_URL }}
  path: .gitlab/lava/corstone1000-mps3/idt_greengrass.yml.j2
  gitlab-job-url: {{ CI_JOB_URL }}

{%- if FREQUENCY == 'adhoc' %}
priority: medium
{%- else %}
priority: low
{%- endif %}
visibility:
  group:
    - cassini

notify:
  criteria:
    status: finished
  callbacks:
    - url: "{{ CI_API_V4_URL }}/projects/{{ CI_PROJECT_ID }}/jobs/{{ TEST_COMPLETE_JOB_ID }}/play"
      method: POST
      token: "{{ LAVA_CALLBACK_TOKEN }}"
      header: "PRIVATE-TOKEN"
      dataset: minimal

context:
  boot_character_delay: 250
  test_character_delay: 250

actions:

- boot:
    namespace: uart0
    method: new_connection
    connection: uart0

- boot:
    namespace: uart1
    method: new_connection
    connection: uart1

- boot:
    namespace: uart3
    method: new_connection
    connection: uart3

# Booting the mps3 test suite
- deploy:
    to: flasher
    images:
      recovery_image:
        url: "{{ FIRMWARE_ARTIFACT }}"
    namespace: target
    timeout:
      minutes: 5

# Run kernel in Flash to copy rootfs overlay to USB stick
- boot:
    namespace: target
    method: u-boot
    timeout:
      minutes: 30
    commands:
      - run retrieve_kernel_load_addr
      - echo Loading kernel from $kernel_addr to memory ...
      - unzip $kernel_addr 0x90000000
      - loadm 0x90000000 $kernel_addr_r $filesize
      - bootefi $kernel_addr_r $fdtcontroladdr
    parameters:
      kernel-start-message: 'Linux version [0-9]'
    auto_login:
      login_prompt: 'corstone1000-mps3 login:.*'
      username: root
    prompts:
      - '@corstone1000-mps3:.+# '

#
# Fudge to enable bmap-tool usage
#
- deploy:
    namespace: poky
    timeout:
      minutes: 5
    to: usb
    os: oe
    images:
      image:
        url: "{{ UTIL_ARTIFACT }}"
        compression: bz2
    uniquify: false
    device: usb_storage_device
    download:
      tool: /usr/bin/wget
      options: --no-check-certificate -O - {DOWNLOAD_URL}
      prompt: "Connecting to .+"
    writer:
      tool: /bin/tar
      options: -C / -xf -
      prompt: 'writing to stdout'
    tool:
      prompts:
        - 'written to stdout'

#
# Deploy the cassini uefi image stored as artifacts by the build job
#
- deploy:
    namespace: secondary_media
    timeout:
      minutes: 150
    to: usb
    os: oe
    images:
      image:
        url: "{{ IMAGE_ARTIFACT }}"
        compression: gz
      bmap:
        url: "{{ BMAP_ARTIFACT }}"
    uniquify: false
    device: usb_storage_device
    writer:
      tool: /usr/bin/bmaptool
      options: copy {DOWNLOAD_URL} /dev/sda
      prompt: 'bmaptool: info'
    tool:
      prompts: ['copying time: [0-9hms\.\ ]+, copying speed [0-9\.]+ [MK]iB\/sec']

- boot:
    namespace: secondary_media
    method: minimal
    timeout:
      minutes: 40
    parameters:
      kernel-start-message: 'Linux version [0-9]'
    auto_login:
      login_prompt: 'corstone1000-mps3 login:.*'
      username: cassini
      login_commands:
      - cassini123
      - cassini123
      - sudo su -
      - eth0=$(ip -o link show | grep "link/ether" | head -n 1 | awk '-F:' '{print $2}')
      - wait-online.sh $eth0
    prompts:
      - 'Password: '
      - 'New password: '
      - 'Re-enter new password: '
      - '@corstone1000-mps3:.+\$ '
      - '@corstone1000-mps3:.+# '
    transfer_overlay:
      download_command: wget -S
      unpack_command: tar -C / -xzf

# CORSTONE-MPS3
- test:
    namespace: secondary_media
    timeout:
      minutes: 10
    definitions:
      - repository:
          metadata:
            format: Lava-Test Test Definition 1.0
            name: Greengrass-Sanity-Test
            description: 'Greengrass-Sanity-Test'
            os:
              - oe
            scope:
              - functional
          run:
            steps:
              - export GG_HOME={{ GG_HOME }}
              - export IOT_KEY_NAME=rsa-signed-key-{{ MACHINE }}-{{ CI_JOB_ID }}
              - sudo mkdir /tmp/idt
              - sudo chown -R cassini:cassini /tmp/idt
              - sudo parsec-tool create-rsa-key -s --key-name $IOT_KEY_NAME
              - sudo parsec-tool create-csr --key-name $IOT_KEY_NAME --cn $IOT_KEY_NAME >$GG_HOME/$IOT_KEY_NAME.csr
              - sudo chmod 755 $GG_HOME
              - sudo chown -R cassini:cassini $GG_HOME
        from: inline
        name: Greengrass-Sanity-Test
        path: inline/Greengrass-Sanity-Test.yaml

# Tester - Provision Device Under Test
- test:
    namespace: secondary_media
    docker:
      image: {{ IDT_GREENGRASS_IMAGE }}
    timeout:
      minutes: 20
    definitions:
      - repository:
          metadata:
            format: Lava-Test Test Definition 1.0
            name: Greengrass-Provision-DUT
            description: "Greengrass Provision DUT"
            os:
            - oe
            scope:
            - functional
          run:
            steps:
              - aws configure set aws_access_key_id {{ AWS_ACCESS_KEY_ID }}
              - aws configure set aws_secret_access_key {{ AWS_SECRET_ACCESS_KEY }}
              - aws configure set region {{ AWS_DEFAULT_REGION }}
              - export IOT_THING_NAME=Device-Cassini-Greengrass-Thing-{{ MACHINE }}-{{ CI_JOB_ID }}
              - export THING_IP=$(lava-target-ip)
              - export IOT_KEY_NAME=rsa-signed-key-{{ MACHINE }}-{{ CI_JOB_ID }}
              - export IOT_TE_ROLE_ALIAS={{ IOT_TE_ROLE_ALIAS }}
              - export IOT_TE_ROLE_POLICY_ALIAS={{ IOT_TE_ROLE_POLICY_ALIAS }}
              - export IOT_THING_POLICY={{ IOT_THING_POLICY }}
              - export IOT_THING_GROUP={{ IOT_THING_GROUP }}
              - mkdir -p ${GG_HOME}
              - scp -o "StrictHostKeyChecking no" cassini@$THING_IP:$GG_HOME/$IOT_KEY_NAME.csr $GG_HOME/
              - /tester/scripts/iot_device_provision.sh
              - rm $GG_HOME/$IOT_KEY_NAME.csr
              - scp -o "StrictHostKeyChecking no" $GG_HOME/* cassini@$THING_IP:$GG_HOME/
        from: inline
        name: Greengrass-Provision-DUT
        path: inline/Greengrass-Provision-DUT.yaml

# CORSTONE-MPS3 - Start Greengrass with generated parameters
- test:
    namespace: secondary_media
    timeout:
      minutes: 30
    definitions:
      - repository:
          metadata:
            format: Lava-Test Test Definition 1.0
            name: Greengrass-Setup-DUT
            description: 'Greengrass Setup DUT'
            os:
              - oe
            scope:
              - functional
          run:
            steps:
              - export IOT_THING_NAME=Device-Cassini-Greengrass-Thing-{{ MACHINE }}-{{ CI_JOB_ID }}
              - export IOT_THING_GROUP={{ IOT_THING_GROUP }}
              - export AWS_DEFAULT_REGION={{ AWS_DEFAULT_REGION }}
              - export GG_HOME={{ GG_HOME }}
              - sudo systemctl stop greengrass
              - rm -rf ${GG_HOME}/logs/*
              - |
              - sudo -E java -Droot="${GG_HOME}" -Dlog.store=FILE -jar "${GG_HOME}/alts/init/distro/lib/Greengrass.jar"
                             --init-config "${GG_HOME}/generated_config.yml"
                             --trusted-plugin "${GG_HOME}/aws.greengrass.crypto.ParsecProvider.jar"
                             --aws-region "${AWS_DEFAULT_REGION}"
                             --thing-name "${IOT_THING_NAME}"
                             --thing-group-name "${IOT_THING_GROUP}"
                             --component-default-user ggc_user:ggc_group
                             --setup-system-service true
                             --start true
                             --provision false
              - |
                until
                  systemctl is-active --quiet greengrass
                do
                  sleep 15
                done
        from: inline
        name: Greengrass-Setup-DUT
        path: inline/Greengrass-Setup-DUT.yaml

# Tester - Run IoT device tester
- test:
    namespace: secondary_media
    docker:
      image: {{ IDT_GREENGRASS_IMAGE }}
    timeout:
      minutes: 720
    definitions:
      - repository:
          metadata:
            format: Lava-Test Test Definition 1.0
            name: Greengrass-Run-IDT
            description: "Greengrass Run IDT"
            os:
            - oe
            scope:
            - functional
          run:
            steps:
              - aws configure set aws_access_key_id {{ AWS_ACCESS_KEY_ID }}
              - aws configure set aws_secret_access_key {{ AWS_SECRET_ACCESS_KEY }}
              - aws configure set region {{ AWS_DEFAULT_REGION }}
              - export THING_IP=$(lava-target-ip)
              - export TARGET_MACHINE={{ MACHINE }}
              - export IDT_ROLE={{ IDT_ROLE }}
              - export TEST_TIMEOUT_MULTIPLIER=10
              - export TEST_SESSION_NAME=IDT-Session-{{ CI_JOB_ID }}
              - export IDT_ROLE_SESSION_DURATION={{ IDT_ROLE_SESSION_DURATION }}
              - /tester/scripts/generate_device_config.sh
              - lava-test-case cassini-greengrass-tests --shell "timeout --foreground 710m /tester/scripts/run_tests.sh"
              - export gg_report_path=$(find /tester/devicetester_greengrass_v2_linux/results/ -xdev -name GGV2Q_Report.xml)
              - jfrog config add --insecure-tls=true artifactory-aws --interactive=false --artifactory-url={{ ARTIFACTORY_AWS_URL }} --user={{ ARTIFACTORY_USER }} --password={{ ARTIFACTORY_PASS }};
              - |
                cat << EOF > ./upload_spec.json
                {
                  "files": [
                    {
                      "pattern": "${gg_report_path}",
                      "target": "{{ ARTIFACTORY_NAMESPACE }}.{{ ARTIFACTORY_TMP_REPO }}/{{ CI_PROJECT_NAME }}/{{ CI_JOB_ID }}/greengrass-results/TEST-Greengrass-test-report.xml",
                      "flat": "true",
                      "recursive": "true"
                    }
                  ]
                }
                EOF
              - build_name="{{ ARTIFACTORY_NAMESPACE }}/{{ CI_PROJECT_PATH }}/{{ CI_JOB_NAME }}"
              - jfrog rt upload --insecure-tls=true --spec=upload_spec.json --build-name="${build_name}" --build-number="{{ CI_JOB_ID }}"
              # Collect environment variables and attach them to a build.
              - jfrog rt build-collect-env "${build_name}" "{{ CI_JOB_ID }}"
              # Publish build info to Artifactory and discard old builds
              - |
                jfrog rt build-publish --insecure-tls=true "${build_name}" "{{ CI_JOB_ID }}" --build-url="{{ CI_PROJECT_URL }}" &&
                jfrog rt build-discard --insecure-tls=true "${build_name}" --max-builds=10 --delete-artifacts --async ||
                echo "Info: build info not supported by Artifactory"
        from: inline
        name: Greengrass-Run-IDT
        path: inline/Greengrass-Run-IDT.yaml

# Tester - Cleanup
- test:
    namespace: secondary_media
    docker:
      image: {{ IDT_GREENGRASS_IMAGE }}
    timeout:
      minutes: 10
    definitions:
      - repository:
          metadata:
            format: Lava-Test Test Definition 1.0
            name: Greengrass-Cleanup-Tests
            description: "Greengrass Cleanup Tests"
            os:
            - oe
            scope:
            - functional
          run:
            steps:
              - aws configure set aws_access_key_id {{ AWS_ACCESS_KEY_ID }}
              - aws configure set aws_secret_access_key {{ AWS_SECRET_ACCESS_KEY }}
              - aws configure set region {{ AWS_DEFAULT_REGION }}
              - export IOT_THING_NAME=Device-Cassini-Greengrass-Thing-{{ MACHINE }}-{{ CI_JOB_ID }}
              - /tester/scripts/aws_cleanup.sh
        from: inline
        name: Greengrass-Cleanup-Tests
        path: inline/Greengrass-Cleanup-Tests.yaml
